package com.adaptrex.core.ext.rest;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adaptrex.core.utilities.StringUtilities;

/*
 * This needs lots of work...
 */
public class ExtConfig {

	private Logger log = LoggerFactory.getLogger(ExtConfig.class);
	
	private Integer start;
	private Integer limit;
	private Map<String,String> extraOptions = new HashMap<String,String>();
	private List<Map<String,String>> sort;
	private List<Map<String,String>> filter;
	
	private String include;
	private String exclude;
	private String associations;
	
	public ExtConfig() {}

	
	@SuppressWarnings("unchecked")
	public ExtConfig(Map<String, List<String>> params) {
		try {
			for (String key : params.keySet()) {
				extraOptions.put(key, params.get(key).get(0));
				
				if (key.equals("limit")) {
					limit = getInt(params.get(key));
					continue;
				}
				
				if (key.equals("start")) {
					start = getInt(params.get(key));
					continue;
				}
				
				if (key.equals("sort")) {
					setSort((List<Map<String, String>>) StringUtilities.fromJson(params.get(key).get(0), List.class));
					continue;
				}
				
				if (key.equals("filter")) {
					setFilter((List<Map<String, String>>) StringUtilities.fromJson(params.get(key).get(0), List.class));
					continue;
				}
				
				if (key.equals("include")) this.setInclude(params.get(key).get(0));
				if (key.equals("exclude")) this.setExclude(params.get(key).get(0));
				if (key.equals("associations")) this.setAssociations(params.get(key).get(0));
				
			}
		} catch (Exception e) {
			log.warn("Error", e);
		}
	}
	
	
	private Integer getInt(List<String> param) {
		return Integer.valueOf((String) param.get(0));
	}
	
	public Map<String,String> getExtraOptions() {
		return extraOptions;
	}
	
	public Integer getLimit() {
		return limit;
	}

	public void setLimit(Integer limit) {
		this.limit = limit;
	}

	public Integer getStart() {
		return start;
	}

	public void setStart(Integer start) {
		this.start = start;
	}

	public List<Map<String,String>> getSort() {
		return sort;
	}

	public void setSort(List<Map<String,String>> sort) {
		this.sort = sort;
	}

	public List<Map<String,String>> getFilter() {
		return filter;
	}

	public void setFilter(List<Map<String,String>> filter) {
		this.filter = filter;
	}
	
	public String getExclude() {
		return exclude;
	}

	public void setExclude(String exclude) {
		this.exclude = exclude;
	}

	public String getInclude() {
		return include;
	}

	public void setInclude(String include) {
		this.include = include;
	}

	public String getAssociations() {
		return associations;
	}

	public void setAssociations(String associations) {
		this.associations = associations;
	}
	
}
