package com.adaptrex.core.ext.rest.provider;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.Map;

import javax.ws.rs.Consumes;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.Request;
import javax.ws.rs.ext.MessageBodyReader;
import javax.ws.rs.ext.Provider;

import com.adaptrex.core.ext.rest.ExtConfig;
import com.adaptrex.core.ext.rest.ModelData;
import com.adaptrex.core.utilities.StringUtilities;


@Provider
@Consumes({MediaType.WILDCARD})
public class ModelDataMessageBodyReader implements MessageBodyReader<ModelData> {

	@Override
	public boolean isReadable(Class<?> type, Type genericType, 
			Annotation[] annotation, MediaType mediaType) {
		return type.equals(ModelData.class);
	}

	@SuppressWarnings("unchecked")
	@Override
	public ModelData readFrom(
			Class<ModelData> clazz, Type genericType, Annotation[] annotations,
			MediaType mediaType, MultivaluedMap<String, String> httpHeaders,
			InputStream entityStream) throws IOException, WebApplicationException {
		
		BufferedReader br = new BufferedReader(new InputStreamReader(entityStream));
		StringBuilder sb = new StringBuilder();
    	String line;
    	while ((line = br.readLine()) != null) {
    		sb.append(line);
    	} 
    	String post = sb.toString();
    	
		return new ModelData((Map<String,Object>) StringUtilities.fromJson(post, Map.class));
	}
}
