package com.adaptrex.core.ext.rest.provider;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.Map;

import javax.ws.rs.Produces;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.ext.MessageBodyWriter;
import javax.ws.rs.ext.Provider;

import com.adaptrex.core.ext.data.Store;
import com.adaptrex.core.ext.rest.ExtConfig;
import com.adaptrex.core.utilities.StringUtilities;


@Provider
@Produces({MediaType.APPLICATION_JSON, MediaType.WILDCARD})
public class StoreJsonBodyWriter implements MessageBodyWriter<Store> {

	@Override
	public long getSize(Store store, Class<?> type, Type genericType,
			Annotation[] annotations, MediaType mediaType) {
		return -1;
	}

	@Override
	public boolean isWriteable(Class<?> type, Type genericType, Annotation[] annotations,
			MediaType mediaType) {
		return type.equals(Store.class);
	}

	@Override
	public void writeTo(Store store, Class<?> clazz, Type type,
			Annotation[] annotation, MediaType mediaType,
			MultivaluedMap<String, Object> map, OutputStream out)
			throws IOException, WebApplicationException {
		final PrintStream printStream = new PrintStream(out);
		
		/*
		 * We need to do some formatting on the response
		 */
		Map<String,Object> response = new HashMap<String,Object>();
		response.put("data", store.getData());
		response.put("total", store.getTotalCount());
		response.put("success", true);
		
		printStream.print(StringUtilities.json(response));
		printStream.close();
	}
}
