package com.adaptrex.core.ext.rest.provider;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.ws.rs.Consumes;
import javax.ws.rs.Produces;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.Request;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.ext.MessageBodyReader;
import javax.ws.rs.ext.MessageBodyWriter;
import javax.ws.rs.ext.Provider;

import com.adaptrex.core.ext.data.Store;
import com.adaptrex.core.ext.rest.ExtConfig;
import com.adaptrex.core.ext.rest.ModelData;
import com.adaptrex.core.utilities.StringUtilities;


@Provider
@Consumes({MediaType.WILDCARD})
public class StoreOptionMessageBodyReader implements MessageBodyReader<ExtConfig> {

	private @Context UriInfo uri;
	
	@Override
	public boolean isReadable(Class<?> type, Type genericType, 
			Annotation[] annotation, MediaType mediaType) {
		return type.equals(ExtConfig.class);
	}

	@Override
	public ExtConfig readFrom(
			Class<ExtConfig> clazz, Type genericType, Annotation[] annotations,
			MediaType mediaType, MultivaluedMap<String, String> httpHeaders,
			InputStream entityStream) throws IOException, WebApplicationException {
		return new ExtConfig(uri.getQueryParameters());
	}
}
