package com.adaptrex.core.security.interceptor;

import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;

import org.apache.shiro.SecurityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adaptrex.core.security.annotation.SecureUser;

@Interceptor
@SecureUser
public class SecureUserInterceptor {

	private static Logger log = LoggerFactory.getLogger(SecureUserInterceptor.class);
	
	@AroundInvoke
    public Object checkSecure(InvocationContext ctx) throws Exception {
		if (SecurityUtils.getSubject().getPrincipal() != null) {
			return ctx.proceed();
		} else {
			log.debug("User Permission Not Authorized for: Anonymous @ " + 
					ctx.getMethod().getDeclaringClass() + "." + ctx.getMethod().getName() + "()");
			return null;
		}
        
    }
	
}
